# coding: utf-8

"""
    DocuSign REST API

    The DocuSign REST API provides you with a powerful, convenient, and simple Web services API for interacting with DocuSign.

    OpenAPI spec version: v2.1
    Contact: devcenter@docusign.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from pprint import pformat
from six import iteritems
import re


class AccountIdentityVerificationWorkflow(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self, default_description=None, default_name=None, input_options=None, signature_provider=None, steps=None, workflow_id=None, workflow_resource_key=None):
        """
        AccountIdentityVerificationWorkflow - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'default_description': 'str',
            'default_name': 'str',
            'input_options': 'list[AccountIdentityInputOption]',
            'signature_provider': 'AccountSignatureProvider',
            'steps': 'list[AccountIdentityVerificationStep]',
            'workflow_id': 'str',
            'workflow_resource_key': 'str'
        }

        self.attribute_map = {
            'default_description': 'defaultDescription',
            'default_name': 'defaultName',
            'input_options': 'inputOptions',
            'signature_provider': 'signatureProvider',
            'steps': 'steps',
            'workflow_id': 'workflowId',
            'workflow_resource_key': 'workflowResourceKey'
        }

        self._default_description = default_description
        self._default_name = default_name
        self._input_options = input_options
        self._signature_provider = signature_provider
        self._steps = steps
        self._workflow_id = workflow_id
        self._workflow_resource_key = workflow_resource_key

    @property
    def default_description(self):
        """
        Gets the default_description of this AccountIdentityVerificationWorkflow.
        

        :return: The default_description of this AccountIdentityVerificationWorkflow.
        :rtype: str
        """
        return self._default_description

    @default_description.setter
    def default_description(self, default_description):
        """
        Sets the default_description of this AccountIdentityVerificationWorkflow.
        

        :param default_description: The default_description of this AccountIdentityVerificationWorkflow.
        :type: str
        """

        self._default_description = default_description

    @property
    def default_name(self):
        """
        Gets the default_name of this AccountIdentityVerificationWorkflow.
        

        :return: The default_name of this AccountIdentityVerificationWorkflow.
        :rtype: str
        """
        return self._default_name

    @default_name.setter
    def default_name(self, default_name):
        """
        Sets the default_name of this AccountIdentityVerificationWorkflow.
        

        :param default_name: The default_name of this AccountIdentityVerificationWorkflow.
        :type: str
        """

        self._default_name = default_name

    @property
    def input_options(self):
        """
        Gets the input_options of this AccountIdentityVerificationWorkflow.
        

        :return: The input_options of this AccountIdentityVerificationWorkflow.
        :rtype: list[AccountIdentityInputOption]
        """
        return self._input_options

    @input_options.setter
    def input_options(self, input_options):
        """
        Sets the input_options of this AccountIdentityVerificationWorkflow.
        

        :param input_options: The input_options of this AccountIdentityVerificationWorkflow.
        :type: list[AccountIdentityInputOption]
        """

        self._input_options = input_options

    @property
    def signature_provider(self):
        """
        Gets the signature_provider of this AccountIdentityVerificationWorkflow.

        :return: The signature_provider of this AccountIdentityVerificationWorkflow.
        :rtype: AccountSignatureProvider
        """
        return self._signature_provider

    @signature_provider.setter
    def signature_provider(self, signature_provider):
        """
        Sets the signature_provider of this AccountIdentityVerificationWorkflow.

        :param signature_provider: The signature_provider of this AccountIdentityVerificationWorkflow.
        :type: AccountSignatureProvider
        """

        self._signature_provider = signature_provider

    @property
    def steps(self):
        """
        Gets the steps of this AccountIdentityVerificationWorkflow.
        

        :return: The steps of this AccountIdentityVerificationWorkflow.
        :rtype: list[AccountIdentityVerificationStep]
        """
        return self._steps

    @steps.setter
    def steps(self, steps):
        """
        Sets the steps of this AccountIdentityVerificationWorkflow.
        

        :param steps: The steps of this AccountIdentityVerificationWorkflow.
        :type: list[AccountIdentityVerificationStep]
        """

        self._steps = steps

    @property
    def workflow_id(self):
        """
        Gets the workflow_id of this AccountIdentityVerificationWorkflow.
        

        :return: The workflow_id of this AccountIdentityVerificationWorkflow.
        :rtype: str
        """
        return self._workflow_id

    @workflow_id.setter
    def workflow_id(self, workflow_id):
        """
        Sets the workflow_id of this AccountIdentityVerificationWorkflow.
        

        :param workflow_id: The workflow_id of this AccountIdentityVerificationWorkflow.
        :type: str
        """

        self._workflow_id = workflow_id

    @property
    def workflow_resource_key(self):
        """
        Gets the workflow_resource_key of this AccountIdentityVerificationWorkflow.
        

        :return: The workflow_resource_key of this AccountIdentityVerificationWorkflow.
        :rtype: str
        """
        return self._workflow_resource_key

    @workflow_resource_key.setter
    def workflow_resource_key(self, workflow_resource_key):
        """
        Sets the workflow_resource_key of this AccountIdentityVerificationWorkflow.
        

        :param workflow_resource_key: The workflow_resource_key of this AccountIdentityVerificationWorkflow.
        :type: str
        """

        self._workflow_resource_key = workflow_resource_key

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
