# coding: utf-8

"""
    DocuSign REST API

    The DocuSign REST API provides you with a powerful, convenient, and simple Web services API for interacting with DocuSign.

    OpenAPI spec version: v2.1
    Contact: devcenter@docusign.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from pprint import pformat
from six import iteritems
import re


class NotaryJurisdiction(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self, commission_expiration=None, commission_id=None, county=None, error_details=None, jurisdiction=None, registered_name=None, seal_type=None):
        """
        NotaryJurisdiction - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'commission_expiration': 'str',
            'commission_id': 'str',
            'county': 'str',
            'error_details': 'ErrorDetails',
            'jurisdiction': 'Jurisdiction',
            'registered_name': 'str',
            'seal_type': 'str'
        }

        self.attribute_map = {
            'commission_expiration': 'commissionExpiration',
            'commission_id': 'commissionId',
            'county': 'county',
            'error_details': 'errorDetails',
            'jurisdiction': 'jurisdiction',
            'registered_name': 'registeredName',
            'seal_type': 'sealType'
        }

        self._commission_expiration = commission_expiration
        self._commission_id = commission_id
        self._county = county
        self._error_details = error_details
        self._jurisdiction = jurisdiction
        self._registered_name = registered_name
        self._seal_type = seal_type

    @property
    def commission_expiration(self):
        """
        Gets the commission_expiration of this NotaryJurisdiction.
        

        :return: The commission_expiration of this NotaryJurisdiction.
        :rtype: str
        """
        return self._commission_expiration

    @commission_expiration.setter
    def commission_expiration(self, commission_expiration):
        """
        Sets the commission_expiration of this NotaryJurisdiction.
        

        :param commission_expiration: The commission_expiration of this NotaryJurisdiction.
        :type: str
        """

        self._commission_expiration = commission_expiration

    @property
    def commission_id(self):
        """
        Gets the commission_id of this NotaryJurisdiction.
        

        :return: The commission_id of this NotaryJurisdiction.
        :rtype: str
        """
        return self._commission_id

    @commission_id.setter
    def commission_id(self, commission_id):
        """
        Sets the commission_id of this NotaryJurisdiction.
        

        :param commission_id: The commission_id of this NotaryJurisdiction.
        :type: str
        """

        self._commission_id = commission_id

    @property
    def county(self):
        """
        Gets the county of this NotaryJurisdiction.
        

        :return: The county of this NotaryJurisdiction.
        :rtype: str
        """
        return self._county

    @county.setter
    def county(self, county):
        """
        Sets the county of this NotaryJurisdiction.
        

        :param county: The county of this NotaryJurisdiction.
        :type: str
        """

        self._county = county

    @property
    def error_details(self):
        """
        Gets the error_details of this NotaryJurisdiction.

        :return: The error_details of this NotaryJurisdiction.
        :rtype: ErrorDetails
        """
        return self._error_details

    @error_details.setter
    def error_details(self, error_details):
        """
        Sets the error_details of this NotaryJurisdiction.

        :param error_details: The error_details of this NotaryJurisdiction.
        :type: ErrorDetails
        """

        self._error_details = error_details

    @property
    def jurisdiction(self):
        """
        Gets the jurisdiction of this NotaryJurisdiction.

        :return: The jurisdiction of this NotaryJurisdiction.
        :rtype: Jurisdiction
        """
        return self._jurisdiction

    @jurisdiction.setter
    def jurisdiction(self, jurisdiction):
        """
        Sets the jurisdiction of this NotaryJurisdiction.

        :param jurisdiction: The jurisdiction of this NotaryJurisdiction.
        :type: Jurisdiction
        """

        self._jurisdiction = jurisdiction

    @property
    def registered_name(self):
        """
        Gets the registered_name of this NotaryJurisdiction.
        

        :return: The registered_name of this NotaryJurisdiction.
        :rtype: str
        """
        return self._registered_name

    @registered_name.setter
    def registered_name(self, registered_name):
        """
        Sets the registered_name of this NotaryJurisdiction.
        

        :param registered_name: The registered_name of this NotaryJurisdiction.
        :type: str
        """

        self._registered_name = registered_name

    @property
    def seal_type(self):
        """
        Gets the seal_type of this NotaryJurisdiction.
        

        :return: The seal_type of this NotaryJurisdiction.
        :rtype: str
        """
        return self._seal_type

    @seal_type.setter
    def seal_type(self, seal_type):
        """
        Sets the seal_type of this NotaryJurisdiction.
        

        :param seal_type: The seal_type of this NotaryJurisdiction.
        :type: str
        """

        self._seal_type = seal_type

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
